/*-------------------------------------------------------------------
 *
 *  @file names.h
 *
 *  @author Collin R. Mulliner <collin@mulliner.org>
 *
 *  This is part of the Bluetooth Location Tracker (BLT) project.
 *
 *  --
 *
 *  For information see: names.c
 *
 *-------------------------------------------------------------------*/

#ifndef __NAMES_H__
#define __NAMES_H__

#define BLT_DEVICE_NAMES_FILE "blt_device_names.dn"

#define DN_HASHTABLE_SIZE 4093
/* prims: 1021, 2039, 4093, 8191, 16381, 32749, 65521, 131071 */

#ifdef DN_TREE
struct tnode_t {
	struct tnode_t *l;					/**< smaller node */
	struct tnode_t *r;					/**< bigger node */
	struct blt_device_status_t dev;	/**< device data */
};
#endif

struct blt_dev_names_t {

	#ifdef DN_HASH
	struct blt_device_status_t *devices;	/**< device store */
	unsigned int maxNumDevices;				/**< store size */
	#endif
	
	#ifdef DN_TREE
	struct tnode_t *devices;	/**< device store */
	#endif
	
	unsigned int numDevices;	/**< number of devices */
};
#endif

int blt_dn_write(struct blt_dev_names_t *dn, struct blt_device_status_t *nDev);
int blt_dn_read(struct blt_dev_names_t *dn, struct blt_device_status_t *nDev);
void blt_dn_init(struct blt_dev_names_t *dn);
void blt_dn_destroy(struct blt_dev_names_t *dn);
